Lua_OutLineAddWindow = class("Lua_OutLineAddWindow", Lua_Window);
function Lua_OutLineAddWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_OutLineAddWindow";
	self.skinName = "OutLineAddWindow_skin";
	self.clickAddClose = false;
	self.isClickClose = true;
end

function Lua_OutLineAddWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.commonId = Lua_CommonUtil.getCommonConfig("outline_item", 1);
	self:addLuaEvent("PACK_UPDATE", self, self.updatePackData);
	self:addLuaEvent("OUT_LINE_TIME", self, self.onOutLineTime);
	self:updatePackData();
	self:onOutLineTime();
	self.addBtn:addClickFuntion(self, self.onAddClick);
	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.btn:addClickFuntion(self, self.onUseClick);
	self.numBg:addClickFuntion(self, self.onNumberBgClick);
	sendMsg(11404303);
end

function Lua_OutLineAddWindow:showWin(param)
	self:superCall("showWin", param);
	
	self.clickAddClose = true;
	self.itemId = param.id;

	self:updatePackData();
end

function Lua_OutLineAddWindow:onOutLineTime(o)
	self.timeTxt.text = TimeTransform.getInstance():transSeconds3(DataCenter.hangUpSettingsData.outLineLeftTime,false);
end

function Lua_OutLineAddWindow:updatePackData()
	if self.toolImg == nil then
		self.toolImg = Lua_ToolImage.new(self.content);
	end
	self.toolImg:setDepth(5);

	if self.itemId == nil or self.itemId == 0 then
		self.itemId = self.commonId;
	end
	self.itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.itemId);
	self.toolImg:setLocation(0, 86, 0);
	
	local tvo = Lua_ToolVo.createToolVo(self.itemId, self.itemNum, 0);
	self.toolImg.data = tvo;
	
	local t = tvo.config.effect_prop.value;
	local maxTime = DataCenter.hangUpSettingsData:getMaxHookTime();
	local lt = 0;
	if DataCenter.hangUpSettingsData.outLineLeftTime == nil then
		lt = maxTime - 0;
	else
		lt = maxTime - DataCenter.hangUpSettingsData.outLineLeftTime;
	end
	local n = math.floor(lt / t);
	self.num = n;
end

function Lua_OutLineAddWindow:setNum(val)
	self.num = val;
end

function Lua_OutLineAddWindow.Set:num(val)
	self._num = val;
	if self._num < 1 then
		self._num = 1;
	end
	if self._num > self.itemNum then
		self._num = self.itemNum;
	end
	if self._num == 0 then
		self._num = 1;
	end
	self.numTxt.text = tostring(self._num);
end

function Lua_OutLineAddWindow:onAddClick(o)
	self.num = self._num + 1;
end

function Lua_OutLineAddWindow:onSubClick(o)
	self.num = self._num - 1;
end

function Lua_OutLineAddWindow:onNumberBgClick(o)
	self.numArr = Array();
	local list = { };
	list.pox = 350;
	list.poy = -6.5;
	list.callBackOwner = self;
	list.callBack = self.onInputClick;
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, list);
end

function Lua_OutLineAddWindow:onInputClick(data)
	if data.state == 1 then
		self.numArr:add(data.num);
		local str = "";
		for i=1,self.numArr:getSize() do
			str = str..self.numArr[i];
		end
		self:setNum(tonumber(str));
	elseif data.state == 0 then
		self:setNum(0);
		self.numArr:clear();
	end
end

function Lua_OutLineAddWindow:onUseClick(o)
	local maxTime = DataCenter.hangUpSettingsData:getMaxHookTime();
	if maxTime <= DataCenter.hangUpSettingsData.outLineLeftTime then
		OperateAlert.show(LanUtil.getValue(110230));
		return;
	end
	
	if self.itemNum == 0 then
		if self.itemId == self.commonId then
			Lua_WindowUtil.openWin("Lua_ItemBuyWindow", nil, {itemId=self.itemId, moneyType=Lua_MoneyData.GOLD_AND_BINDGOLD});
		else
			self:hide();
			return
		end
	else
		local tvo2 = Lua_ToolVo.createToolVo(self.itemId, 1, 1)
		local oneItemTime = tvo2.effect_prop.value;
		local addTime = self._num * oneItemTime;
		local all_time = addTime + DataCenter.hangUpSettingsData.outLineLeftTime;
		
		if all_time > maxTime then--溢出
			local tipData = {};
			tipData.des = LanUtil.getValue(110229);
			tipData.owner = self;
			tipData.type = 1;
			tipData.subFun = self.onTipSubClick;   --确定
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		else
			local arr = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsById(self.itemId);
			local tvo = arr[1];
			local useNum = math.min(tvo.count, self._num);
			local msg = ProtoPublic_pb.Proto11400106();
			msg.index = tvo.index;
			msg.amount = useNum;
			sendMsg(11400106, msg);
			if self.clickAddClose == true then
				self:hide();
			end
		end
	end
end

function Lua_OutLineAddWindow:onTipSubClick()
	local arr = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsById(self.itemId);
	local tvo = arr[1];
	local useNum = math.min(tvo.count, self._num);
	local msg = ProtoPublic_pb.Proto11400106();
	msg.index = tvo.index;
	msg.amount = useNum;
	sendMsg(11400106, msg);
	if self.clickAddClose == true then
		self:hide();
	end
end